/*
  Copyright (C) 2009 Julien Jorge

  This program is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published by the
  Free Software Foundation; either version 2 of the License, or (at your
  option) any later version.

  This program is distributed in the hope that it will be useful, but WITHOUT
  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
  more details.

  You should have received a copy of the GNU General Public License along
  with this program; if not, write to the Free Software Foundation, Inc.,
  51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

  contact: julien.jorge@gamned.org
*/
#include "image.hpp"
#include "my_context.hpp"

#include <iostream>

// retourne l'image horizontalement
void image::miroir()
{
  std::cout << __FUNCTION__ << std::endl;
}

// tourne l'image d'un angle \a a autour du centre de position (\a cx, \a cy).
void image::tourner( double a, int cx, int cy )
{
  std::cout << __FUNCTION__ << ' ' << a << ' ' << cx << ' ' << cy
            << std::endl;
}

// copie l'image \a img  la position (\a x, \a y)
void image::copier( const image& img, int x, int y )
{
  std::cout << __FUNCTION__ << ' ' << &img << ' ' << x << ' ' << y
            << std::endl;
}

/** Il faut connecter les mthodes pour qu'elles puisse tre excutes */
void image::set_exported()
{
  CONNECT_METHOD_0( image, miroir, void );
  CONNECT_METHOD_3( image, tourner, void, double, int, int );
  CONNECT_METHOD_3( image, copier, void, const image&, int, int );
}

IMPLEMENT_METHOD_LIST(image)
