/*
  Copyright (C) 2009 Julien Jorge

  This program is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published by the
  Free Software Foundation; either version 2 of the License, or (at your
  option) any later version.

  This program is distributed in the hope that it will be useful, but WITHOUT
  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
  more details.

  You should have received a copy of the GNU General Public License along
  with this program; if not, write to the Free Software Foundation, Inc.,
  51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

  contact: julien.jorge@gamned.org
*/
#include "my_context.hpp"
#include "image.hpp"

/** Spcialisation pour retourner une image  partir de son nom. */
const image& script::string_to_arg<my_context, const image&>::convert
( const my_context& context, const std::string& arg )
{
  return *context.get_image(arg);
}

// ajoute une image \a img nomme \a n dans le contexte
void my_context::add( const std::string& n, image* img )
{
  m_images[n] = img;
  m_export[n] = img;
}

// ajoute un objet \a e nomm \a n dans le contexte
void my_context::add( const std::string& n, my_exportable* e )
{
  m_export[n] = e;
}

// rcupre un objet en fonction de son nom \a n
my_exportable* my_context::get( const std::string& n ) const
{
  return m_export.find(n)->second;
}

// rcupre une image en fonction de son nom \a n
image* my_context::get_image( const std::string& n ) const
{
  return m_images.find(n)->second;
}
