/*
  Copyright (C) 2009 Julien Jorge

  This program is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published by the
  Free Software Foundation; either version 2 of the License, or (at your
  option) any later version.

  This program is distributed in the hope that it will be useful, but WITHOUT
  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
  more details.

  You should have received a copy of the GNU General Public License along
  with this program; if not, write to the Free Software Foundation, Inc.,
  51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

  contact: julien.jorge@gamned.org
*/
#ifndef __SCRIPT_GET_INNER_TYPE__
#define __SCRIPT_GET_INNER_TYPE__

namespace script
{
  /** get_inner_type permet de retrouver le type au c~ur d'une
    dclaration, en supprimant les const et les &. Par exemple,
    get_inner_type<const int&>::type est int. */
  template<typename T>
  class get_inner_type
  {
  public:
    typedef T type;
  };

  template<typename T>
  class get_inner_type<const T>: public get_inner_type<T>
  { };

  template<typename T>
  class get_inner_type<const T&>: public get_inner_type<T>
  { };

} // namespace script

#endif // __SCRIPT_GET_INNER_TYPE__
