/*
  Copyright (C) 2009 Julien Jorge

  This program is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published by the
  Free Software Foundation; either version 2 of the License, or (at your
  option) any later version.

  This program is distributed in the hope that it will be useful, but WITHOUT
  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
  more details.

  You should have received a copy of the GNU General Public License along
  with this program; if not, write to the Free Software Foundation, Inc.,
  51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

  contact: julien.jorge@gamned.org
*/
#ifndef __SCRIPT_STRING_TO_ARG_HPP__
#define __SCRIPT_STRING_TO_ARG_HPP__

#include "script/get_inner_type.hpp"

#include <sstream>
#include <string>

namespace script
{
  /** Convertit un paramtre une valeur de type T. */
  template<typename Context, typename T>
  class string_to_arg
  {
  public:
    typedef typename get_inner_type<T>::type result_type;

    static result_type convert( const Context& context, const std::string& arg )
    {
      result_type result;
      std::istringstream iss(arg);
      iss >> result;
      return result;
    }
  }; // class string_to_arg
} // namespace script

#endif // __SCRIPT_STRING_TO_ARG_HPP__
