/*
  Copyright (C) 2009 Julien Jorge

  This program is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published by the
  Free Software Foundation; either version 2 of the License, or (at your
  option) any later version.

  This program is distributed in the hope that it will be useful, but WITHOUT
  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
  more details.

  You should have received a copy of the GNU General Public License along
  with this program; if not, write to the Free Software Foundation, Inc.,
  51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

  contact: julien.jorge@gamned.org
*/
#include "script_exec.hpp"
#include <vector>
#include <sstream>
#include <string>

script_exec::script_exec()
{
  m_context.add("mailer", &m_mailer);
}

void script_exec::add_image( const std::string& name, image* a )
{
  m_context.add(name, a);
}

void script_exec::execute_command( const std::string& command )
{
  std::istringstream iss(command);
  std::string name;
  std::string method;
  std::vector<std::string> args;

  iss >> name >> method;
  std::string a;

  while ( iss >> a )
    args.push_back(a);
    
  m_context.get(name)->execute( method, args, m_context );
}
